function Vector(n)
{
    this.vector = new Array(n);
	for(var i=0;i<n;i++)
	{
	   this.vector[i] = 0.0;    	 
	}
	
	this.Size = function()
	{
	    return this.vector.length;   
	}
    
    this.toString = function()
	{
		var str = "[ ";
	    for(var i=0;i<this.vector.length;i++)
	    {
	        str += this.vector[i] + "; "; 
	    }
	    return str + " ]";		
	}
	
	this.toFixed = function(p)
	{
		var str = "[ ";
		var num;
	    for(var i=0;i<this.vector.length;i++)
	    {
	        num = new Number(this.vector[i]);
	        str += num.toFixed(p) + "; "; 
	    }
	    return str + " ]";		
	}
	
	this.toPrecision = function(p)
	{
		var str = "[ ";
		var num;
	    for(var i=0;i<this.vector.length;i++)
	    {
	        num = new Number(this.vector[i]);
	        str += num.toPrecision(p) + "; "; 
	    }
	    return str + " ]";		
	}
	
	this.toExponential = function(p)
	{
		var str = "[ ";
		var num;
	    for(var i=0;i<this.vector.length;i++)
	    {
	        num = new Number(this.vector[i]);
	        str += num.toExponential(p) + "; "; 
	    }
	    return str + " ]";		
	}
	
	this.Dot = function(v)
	{
       x = this.vector;
       y = v.valueOf();
       n = x.length;
       
       var res = 0;
       
       for(var i=0; i<n; i++)
         res += x[i]*y[i]; 
         
       return res;  	
	}
	
	this.valueOf = function()
	{
	    return this.vector;
	}
}


function LUP(L,U,P,Pv,par)
{
    this.L = L;
    this.U = U;
    this.P = P;
    this.Pv = Pv;
    this.parity = par; 
    
    this.Solve = function(v)
    {
        if(Vector.prototype.isPrototypeOf(v))
            return this.Solve1(v);
        else    
            return this.SolveN(v);
    } 
    
    this.Solve1 = function(v)
    {
        var L = this.L.matrix;
        var U = this.U.matrix;
        var P = this.P.matrix;
        var Pv = this.Pv.valueOf();
        var b = v.valueOf();
        
        var n = L.length;
        var ou = new Vector(n); var u = ou.valueOf();
        var ox = new Vector(n); var x = ox.valueOf();
        var suma;
        u[0] = b[Pv[0]];
        for(i=1;i<n;i++)
        {
            suma = 0;
            for(j=0;j<i;j++) suma += L[i][j]*u[j];
            u[i] = b[Pv[i]]-suma;
        }
        x[n-1] = u[n-1]/U[n-1][n-1];
        for(i=n-2; i>=0; i--)
        {
            suma = 0;
            for(j=i+1;j<n;j++) suma += U[i][j]*x[j];
            x[i] = (u[i]-suma)/U[i][i];
        }
        return ox;    
    }
    
    this.SolveN = function(v)
    {
        var L = this.L.matrix;
        var U = this.U.matrix;
        var P = this.P.matrix;
        var Pv = this.Pv.valueOf();
        var b = v.valueOf();
        var sz = v.Size().valueOf();
        var p = sz[1];
        
        var n = L.length;
        var ou = new Matrix(n,p); var u = ou.valueOf();
        var ox = new Matrix(n,p); var x = ox.valueOf();
        var suma;
        for(k=0;k<p;k++)
        {
            u[0][k] = b[Pv[0]][k];
            for(i=1;i<n;i++)
            {
                suma = 0;
                for(j=0;j<i;j++) suma += L[i][j]*u[j][k];
                u[i][k] = b[Pv[i]][k]-suma;
            }
            x[n-1][k] = u[n-1][k]/U[n-1][n-1];
            for(i=n-2; i>=0; i--)
            {
                suma = 0;
                for(j=i+1;j<n;j++) suma += U[i][j]*x[j][k];
                x[i][k] = (u[i][k]-suma)/U[i][i];
            }
        }
        return ox;    
    }
    
    this.Determinant = function()
    {
        var U = this.U.matrix;
        var n = U.length;
        var D = this.parity;
        for(var i=0; i<n; i++)
            D *= U[i][i];
        return D;    
    }
    
    this.Inverse = function()
    {
        var n = this.L.matrix.length;
        var E = eye(n);
        return this.SolveN(E);
    }
       
}

function Matrix(n,m)
{
	this.matrix = new Array(n);

    if(!m) var m = n;  
	
	for(var i=0;i<n;i++)
	{
		this.matrix[i]=new Array(m);
	    for(var j=0;j<m;j++)
	    {
	        this.matrix[i][j] = 0.0;    
	    }	 
	}
	
	this.Size = function()
	{
	    var r = new Vector(2);
	    v = r.valueOf();
	    v[0] = this.matrix.length;
	    v[1] = this.matrix[0].length;
	    return r;
	}
	
	this.Mult2 = function(x,b)
	{
	    var n = this.matrix.length;
	    var m = this.matrix[0].length;
	    var r = new Vector(n);
	    var v = r.valueOf();
	    if(x.Size() != m)
	    {
	        alert("Wrong size!"); return;
	    }
	    if(arguments.length == 2 && b.Size() != m)
	    {
	        alert("Wrong size!"); return;
	    }
	    var vx = x.valueOf();
	    var vb;
	    if( arguments.length == 2 )
	        vb = b.valueOf();
	    for(var i=0;i<n;i++)
	    {
	        for(var k=0;k<m;k++)
	            v[i] += this.matrix[i][k]*vx[k];
	        if( arguments.length == 2 )
	            v[i] += vb[i];
	    }
	    return r;              
	}
	
	this.Mult = function(s)
	{
	    var n = this.matrix.length;
	    var m = this.matrix[0].length;
	    var r; 
	    var v; 
	        
	    if(!s.Size)
	    {
	        r = new Matrix(n,m);
	        v = r.valueOf();
	        for(var i=0;i<n;i++)
	        for(var j=0;j<m;j++)
	             v[i][j]= this.matrix[i][j]*s;     
	    }
	    else
	    if(typeof(s.Size())!="number")
	    {
	        var sz = s.Size().valueOf();     
	        if(m != sz[0]) 
	        {
	            alert("Wrong size!");
	            return;
	        }
	        var p = sz[1];
	        r = new Matrix(n,p);
	        v = r.valueOf();
	        var vs = s.valueOf();
	        for(var i=0; i<n; i++)
	        for(var j=0; j<p; j++)
	        for(var k=0; k<m; k++)
	            v[i][j] += this.matrix[i][k]*vs[k][j];     
	    }
	    else
	    {
	        r = this.Mult2(s);
	    }
	    return r;
	}
	
    this.Add = function(s)
	{
	    var n = this.matrix.length;
		var m = this.matrix[0].length;
		var r = new Matrix(n,m);
	    var v = r.valueOf();
		
	    if(!s.Size)
	    {
	        for(var i=0;i<n;i++)
	        for(var j=0;j<m;j++)
	            v[i][j] = this.matrix[i][j] + s;
	    }
	    else
	    if(s.Size().Size())
	    {
	        var sz = s.Size().valueOf();     
	        if(m != sz[0] || m != sz[1]) 
	        {
	            alert("Wrong size");
	            return;
	        }
	        
	        var vs = s.valueOf();
	        for(var i=0; i<n; i++)
	        for(var j=0; j<m; j++)
	            v[i][j] = this.matrix[i][j]+vs[i][j];
	    } 
	    return r;            
	}
	
	this.Sub = function(s)
	{ 
	    return this.Add(s.Mult(-1));            
	}
	
	this.Diag = function()
	{
	    var n = this.matrix.length;
	    var m = this.matrix[0].length;
	    if(n != m)
	    {
	        alert("Matrix must be squared");
	        return;
	    }
	    var r = new Matrix(n);
	    var v = r.valueOf();
	        for(var i=0; i<n; i++)
	            v[i][i] = this.matrix[i][i];
	    return r;        
	}
	
	this.Tril = function()
	{
	    var n = this.matrix.length;
	    var m = this.matrix[0].length;
	    if(n != m)
	    {
	        alert("Matrix must be squared");
	        return;
	    }
	    var r = new Matrix(n);
	    var v = r.valueOf();
	        for(var i=0; i<n; i++)
	        for(var j=0; j<=i; j++)
	            v[i][j] = this.matrix[i][j];
	    return r;        
	}

	this.Triu = function()
	{
	    var n = this.matrix.length;
	    var m = this.matrix[0].length;
	    if(n != m)
	    {
	        alert("Matrix must be squared");
	        return;
	    }
	    var r = new Matrix(n);
	    var v = r.valueOf();
	        for(var i=0; i<n; i++)
	        for(var j=i; j<n; j++)
	            v[i][j] = this.matrix[i][j];
	    return r;        
	}
	 	
	this.toString = function()
	{
		var str = "[ ";
		var n = this.matrix.length;
		var m = this.matrix[0].length;
	    for(var i=0;i<n;i++)
	    {
	        for(var j=0;j<m;j++)
	        {
	            str += this.matrix[i][j] + " "; 
	        }
	        if(i < n-1) str += "\n";	 
	    }
	    return str + " ]";		
	}
	
	this.toFixed = function(p)
	{
		var str = "[ ";
		var n = this.matrix.length;
		var m = this.matrix[0].length;
	    var num;
	    for(var i=0;i<n;i++)
	    {
	        for(var j=0;j<m;j++)
	        {
	            num = new Number(this.matrix[i][j]);
	            str += num.toFixed(p) + " "; 
	        }
	        if(i < n-1) str += "\n";	 
	    }
	    return str + " ]";
	}
	
	this.toPrecision = function(p)
	{
		var str = "[ ";
		var n = this.matrix.length;
		var m = this.matrix[0].length;
	    var num;
	    for(var i=0;i<n;i++)
	    {
	        for(var j=0;j<m;j++)
	        {
	            num = new Number(this.matrix[i][j]);
	            str += num.toPrecision(p) + " "; 
	        }
	        if(i < n-1) str += "\n";	 
	    }
	    return str + " ]";
	}

	this.toExponential = function(p)
	{
		var str = "[ ";
		var n = this.matrix.length;
		var m = this.matrix[0].length;
	    var num;
	    for(var i=0;i<n;i++)
	    {
	        for(var j=0;j<m;j++)
	        {
	            num = new Number(this.matrix[i][j]);
	            str += num.toExponential(p) + " "; 
	        }
	        if(i < n-1) str += "\n";	 
	    }
	    return str + " ]";
	}


	this.FindPivot = function(A,k)
	{
		var amax = Math.abs(A[k][k]);
		var imax = k;
		var val;
		var n = A.length;
		for(var i=k+1; i<n; i++)
		{
			val = Math.abs(A[i][k]);
			if(val>amax)
			{
				amax = val; imax = i;
			}		 
		}
		return imax;
	}
		
	this.SwapRows = function(M,r1,r2)
	{
		var v;
		v = M[r1];
		M[r1] = M[r2];
		M[r2] = v;
	}
	
	this.SwapElements = function(v,r1,r2)
	{
	    var x;
	    x = v[r1]; v[r1] = v[r2]; v[r2] = x; 
	} 
	
	this.LU = function()
	{
	    var n = this.matrix.length;
	    var oL = new Matrix(n,n);
	    var oU = new Matrix(n,n);
	    var oP = new Matrix(n,n);
	    var oPv = new Vector(n);
	    
	    var L = oL.matrix;
	    var U = oU.matrix;
	    var P = oP.matrix;
	    var Pv = oPv.vector;
	    
	    var par = 1.0;
	    
	    var m;
	    
	    for(var i=0; i<n; i++)
		{
		    P[i][i] = 1.0; L[i][i] = 1.0; Pv[i] = i;
		}
		
		var A = new Array(n);
		for(var i=0; i<n; i++)
		{
		    A[i] = new Array(n);
		    for(var j=0; j<n; j++)
		    {
		        A[i][j] = this.matrix[i][j];
		    }    
		}
		
		for(var k=0; k<n-1; k++)
		{
            var ip = this.FindPivot(A,k);
            if(ip != k)
            {
                this.SwapRows(A,ip,k); this.SwapRows(P,ip,k); 
                this.SwapElements(Pv,ip,k); par *= -1.0;
            }   
                
            var d;
            
            for(var i=k+1; i<n; i++)
            {
                d=A[k][k];
                if(d==0) { alert("Singulrn matice!"); return; }
                m = A[i][k]/d;
                A[i][k] = m;
                for(var j=k+1; j<n; j++)
                A[i][j] -=  m*A[k][j];
            }     		    
		}
		
		for(var i=1; i<n; i++)
        for(var j=0; j<i; j++)        		
		    L[i][j] = A[i][j];
        
        for(var i=0; i<n; i++)
        for(var j=i; j<n; j++)    
	        U[i][j] = A[i][j];
          
	    return new LUP(oL,oU,oP,oPv,par);  
	}
	
	this.T = function()
	{
	    var n = this.matrix.length;
	    var m = this.matrix[0].length;
	    var r = new Matrix(m,n);
	    var vr = r.valueOf();
	    var v = this.valueOf();
        for(var i=0; i<m; i++)
        for(var j=0; j<n; j++)    
	        vr[i][j] = v[j][i];
	    return  r;   
	}
	
	this.SubRange = function(r1,r2)
	{
	    var n = r1.Size();
	    var m = r2.Size();
	    var r = new Matrix(n,m);
	    var vr = r.valueOf();
	    var v = this.valueOf();
	    
	    var v1 = r1.valueOf();
	    var v2 = r2.valueOf();
	    
	    for(var i=0; i<n; i++)
        for(var j=0; j<m; j++)    
	        vr[i][j] = v[v1[i]][v2[j]];
	    return r;
	}
	
	this.valueOf = function()
	{
	    return this.matrix;
	}			
}

//Genertory
function zeros()
{
    var r;
    if( arguments.length == 1 )
    {
          var n = arguments[0];
          r = new Vector(n);
    }
    if( arguments.length == 2 )
    {
          var n = arguments[0];
          var m = arguments[1];
          r = new Matrix(n,m);
    }
    return r;
}

function ones()
{
    var r;
    if( arguments.length == 1 )
    {
          var n = arguments[0];
          r = new Vector(n);
          var vr = r.valueOf();
          for(var i=0; i<n; i++)
            vr[i] = 1.0;
    }
    if( arguments.length == 2 )
    {
          var n = arguments[0];
          var m = arguments[1];
          r = new Matrix(n,m);
          var vr = r.valueOf();
          for(var i=0; i<n; i++)
          for(var j=0; j<m; j++)
            vr[i][j] = 1.0;
    }
    return r;
}

function eye(n)
{
    r = new Matrix(n,n);
    var vr = r.valueOf();
    for(var i=0; i<n; i++)
            vr[i][i] = 1.0;            
    return r;
}

var randMin = -5, randMax = 5;

function rand()
{
    var r;
    var h = randMax-randMin;         
    
    if( arguments.length == 1 )
    {
          var n = arguments[0];
          r = new Vector(n);
          v = r.valueOf();
          for(var i=0; i<n; i++)
            v[i] = randMin + Math.random()*h;    
    }
    
    if( arguments.length == 2 )
    {
          var n = arguments[0];
          var m = arguments[1];
          r = new Matrix(n,m);
          v = r.valueOf();
          for(var i=0; i<n; i++)
          for(var j=0; j<m; j++)
            v[i][j] = randMin + Math.random()*h;     
    }
    
    return r;
}

function select()
{
    var n = arguments.length;
    var r = new Vector(n);
    for(var i=0; i<n; i++)
        r[i] = arguments[i];
    return r;
}